SystemOrganization addCategory: #'Seaside-Tests-Slime'!

!GRPackage class methodsFor: '*seaside-tests-slime' stamp: 'lr 2/17/2010 15:22'!
seasideTestsSlime
	^ self new
		name: 'Seaside-Tests-Slime';
		description: 'Unit tests for the package Seaside-Slime.';
		addDependency: 'Seaside-Slime';
		addDependency: 'Grease-Tests-Slime';
		addDependency: 'Seaside-Tests-Component';
		url: #seasideUrl;
		yourself! !

GRSlimeTest subclass: #WASlimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeTest methodsFor: 'tests-block' stamp: 'jok 1/27/2010 11:19'!
testCallSuperImplementation
	| object painter |
	object := self
		defineClass: #WASlimeMockObject
		superclass: #WAObject.
	self compile: 'postCopy self postCopy' in: object. 
	painter := self
		defineClass: #WASlimeMockComponent
		superclass: #WAPainter.
	self compile:  'updateRoot: aHtmlRoot self updateUrl: aHtmlRoot' in: painter.
	self
		runRule: WACallSuperImplementationRule
		selectors: #(postCopy updateRoot:)! !

!WASlimeTest methodsFor: 'tests-block' stamp: 'jok 1/27/2010 11:19'!
testChangesStateWhileRendering
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class addInstanceVariable: 'foo'.
	self compile: 'renderContentOn: html html div: [ foo := nil ]' in: class.
	self 
		runRule: WAChangesStateWhileRenderingRule
		selectors: #(renderContentOn:)! !

!WASlimeTest methodsFor: 'tests-block' stamp: 'jok 1/27/2010 11:20'!
testDoNotUseWhileRendering
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	self compile: 'renderContentOn: html html div: [ self call: nil ]' in: class.
	self 
		runRule: WADoNotUseWhileRenderingRule
		selectors: #(renderContentOn:)! !

!WASlimeTest methodsFor: 'tests-block' stamp: 'jok 1/27/2010 11:20'!
testDoNotUseWithinCallback
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	self compile: 'renderContentOn: html
		html anchor
			callback: [ html document addLoadScript: nil ];
			with: 123' in: class.
	self 
		runRule: WADoNotUseWithinCallbackRule
		selectors: #(renderContentOn:)! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'jok 1/27/2010 11:20'!
testExtractCallbackCodeToMethod
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class
		compile: 'renderInvalidOn: html
			html anchor 
				callback: [ self foo. self bar ];
				with: 1'
		classified: #(rendering).
	class
		compile: 'renderValidOn: html
			html anchor 
				callback: [ self foo ];
				with: 1'
		classified: #(rendering).
	self 
		runRule: WAExtractCallbackCodeToMethodRule
		selectors: #(renderInvalidOn:)! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'jok 1/27/2010 11:20'!
testFixCallbackTempsMissing
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	self
		compile: 'callbackTemps | r | r := OrderedCollection new. (1 to: 10) do: [ :e | r add: [ e ] ]' 
		in: class.
	self 
		runRule: WAFixCallbackTempsMissingRule
		selectors: #(callbackTemps)! !

!WASlimeTest methodsFor: 'tests-transform' stamp: 'jok 1/27/2010 11:21'!
testHandleRequestRule
	| class |
	class := self
		defineClass: #WASlimeMockHandler
		superclass: #WARequestHandler.
	self compile: 'handleRequest: aRequest aRequest notFound' in: class.
	self 
		runTransformation: WAHandleRequestRule
		changes: #('handleFiltered: aRequestContext aRequestContext request notFound')! !

!WASlimeTest methodsFor: 'tests-block' stamp: 'jok 1/27/2010 11:21'!
testInstantiatesComponentWhileRendering
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	self compile: 'renderContentOn: html html div: WAComponentStub new' in: class.
	self 
		runRule: WAInstantiatesComponentWhileRenderingRule
		selectors: #(renderContentOn:)! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'jok 1/27/2010 11:21'!
testSendsRenderContentOn
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class
		compile: 'invalid self renderContentOn: nil'
		classified: #(rendering).
	self 
		runRule: WASendsRenderContentOnRule
		selectors: #(invalid)! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'jok 1/27/2010 11:21'!
testSequencedAsynchronousCalls
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class
		compile: 'renderContent1On: html
			html div
				onClick: (html jQuery ajax callback: [  ]) , (html jQuery ajax serializeForm);
				with: ''Click me'''
		classified: #(rendering).
	class
		compile: 'renderContent2On: html
			html div
				onClick: (html jQuery ajax serializeForm; callback: [  ]) , (html jQuery effect bounce);
				with: ''Click me'''
		classified: #(rendering).
	self 
		runRule: WASequencedAsynchronousCallsRule
		selectors: #(renderContent1On: renderContent2On:)! !

!WASlimeTest methodsFor: 'tests-transform' stamp: 'jok 1/27/2010 11:22'!
testSessionExpiredRule
	| class |
	class := self
		defineClass: #WASlimeMockSession
		superclass: #WASession.
	self compile: 'expired self cleanup' in: class.
	self 
		runTransformation: WASessionExpiredRule
		changes: #('unregistered self cleanup')! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'jok 1/27/2010 11:22'!
testUnnecessaryBlockPassedToBrush
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class
		compile: 'renderContent01On: html html div: [ ]'
		classified: #(rendering).
	class
		compile: 'renderContent02On: html html div: [ html text: 2 ]'
		classified: #(rendering).
	class
		compile: 'renderContent03On: html html div: [ html render: 3 ]'
		classified: #(rendering).
	class
		compile: 'renderContent04On: html html div class: #foo; with: [ ]'
		classified: #(rendering).
	class
		compile: 'renderContent05On: html html div class: #foo; with: [ html text: 5 ]'
		classified: #(rendering).
	class
		compile: 'renderContent06On: html html div class: #foo; with: [ html render: 6 ]'
		classified: #(rendering).
	self
		runRule: WAUnnecessaryBlockPassedToBrushRule
		selectors: #(renderContent01On: renderContent02On: renderContent03On: renderContent04On: renderContent05On: renderContent06On:)! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'jok 1/27/2010 11:22'!
testUnnecessaryWithSentToBrush
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class
		compile: 'renderContentOn: html html div with: 123'
		classified: #(rendering).
	self
		runRule: WAUnnecessaryWithSentToBrushRule
		selectors: #(renderContentOn:)! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'jok 1/27/2010 11:22'!
testUsesWrongRenderer
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class
		compile: 'renderContentOn: html
			html updater callback: [ :r | html div ]'
		classified: #(rendering).
	self 
		runRule: WAUsesWrongRendererRule
		selectors: #(renderContentOn:)! !

!WASlimeTest methodsFor: 'tests-parsetree' stamp: 'pmm 9/1/2012 14:48'!
testWithHasToBeLastMessageInCascade
	| class |
	class := self 
		defineClass: #WASlimeMockComponent
		superclass: #WAComponent.
	class
		compile: 'renderContent01On: html
			html div
				with: ''foo'';
				class: ''bar'''
		classified: #(rendering).
	class
		compile: 'renderContent02On: html
			html div
				id: ''zork'';
				with: ''foo'';
				class: ''bar'''
		classified: #(rendering).
	self 
		runRule: WAWithHasToBeLastMessageInCascadeRule
		selectors: #(renderContent01On: renderContent02On:)! !
